# ArViz Godot

ArViz Godot is a front-end of ArViz, the 3D visualization framework of [Armarx](https://armarx.humanoids.kit.edu/).
It is based on the free game engine [Godot](https://godotengine.org/). 


# Installation

## Using [Axii](https://gitlab.com/ArmarX/meta/setup)

When using [Axii](https://gitlab.com/ArmarX/meta/setup), add the module `armarx/core/arviz-godot` 
and run an upgrade:

```shell
axii add armarx/core/arviz-godot
axii upgrade
```

Afterwards, you can start the application via the `arviz-godot` command.

```shell
arviz-godot
```

> Note: You may have to open a new console or re-source your `armarx-workspace.rc` to reload 
> the new environment variables after adding the module. 


## Manual Installation

Clone the repository into `arviz_godot`:

```shell
git clone --recursive git@gitlab.com:ArmarX/core/arviz-godot.git arviz_godot
```

Run CMake and build the target `arviz_godot`:

```shell
cd arviz_godot/build/
cmake ..

cd ..  # i.e. arviz_godot/
cmake --build build --target arviz_godot .
```

Tests are disabled by default. To enable them, run use the `-DUseTest=ON` option.
Some tests require Catch2 to be installed.

To create an executable, Godot export templates must be installed.
Then, the following commands can be used to create an executable:

```shell
# From arviz_godot/
cd source/arviz_interactive_project/components/arviz_interactive/avi
godot --no-window --export "Linux/X11"
```

The executable `avi.x86_64` can then be found in the `./exports` folder.


# Credits

ArViz Godot was originally developed as one of the PSE (Practice of Software Engineering) projects 
of the winter term 2021/22 at the 
[High Performance Humanoid Technologies Lab (H²T)](https://h2t.anthropomatik.kit.edu/english/).
The original authors are:

* Dominic Brestel (@kuumaaa)
* Paul Emil Hannuschka (@p.hannuschka)
* Jean Patrick Mathes (@jp_mathes)
* Eike Simon Scharpf (@Simon_Scharpf)
* Markus Wünstel (@MarkusWuenstel)
