#include "EventList.h"

void
avi::app::EventList::subscribe(std::string event, std::function<void()> callback)
{
    callbacks[event].push_back(callback);
}

void
avi::app::EventList::invoke(const std::string& event)
{
    auto it = callbacks.find(event);

    if (it != callbacks.end())
    {
        for (auto& callback : it->second)
        {
            callback();
        }
    }
}
