#include "KeyInputEventDispatch.h"

#include <InputEvent.hpp>

void
avi::app::KeyInputEventDispatch::_register_methods()
{
    register_method("_unhandled_input", &KeyInputEventDispatch::_unhandled_input);
}

void
avi::app::KeyInputEventDispatch::_init()
{
}

void
avi::app::KeyInputEventDispatch::hookup(avi::core::EventInvokingSystem& events)
{
    this->events = &events;
}

void
avi::app::KeyInputEventDispatch::_unhandled_input(godot::InputEvent* event)
{
    if (event->is_action_pressed("avi_camera_view_reset"))
        events->invoke("VIEW_CAMERA_RESET");
    if (event->is_action_pressed("avi_camera_focus_scene"))
        events->invoke("VIEW_CAMERA_FOCUS_SCENE");
    if (event->is_action_pressed("avi_camera_focus_point"))
        events->invoke("VIEW_CAMERA_FOCUS_POINT");
    if (event->is_action_pressed("avi_lock_mouse"))
        events->invoke("VIEW_CAMERA_LOCK");
    if (event->is_action_pressed("avi_lock_escape"))
        events->invoke("VIEW_CAMERA_ESCAPE_LOCK");

    if (event->is_action_pressed("avi_screenshot"))
        events->invoke("TAKE_SCREENSHOT");
    if (event->is_action_pressed("avi_video"))
        events->invoke("RECORD_VIDEO");

    if (event->is_action_pressed("avi_manipulator_none"))
        events->invoke("MANIPULATOR_NONE");
    if (event->is_action_pressed("avi_manipulator_move"))
        events->invoke("MANIPULATOR_MOVE");
    if (event->is_action_pressed("avi_manipulator_rotate"))
        events->invoke("MANIPULATOR_ROTATE");
    if (event->is_action_pressed("avi_manipulator_scale"))
        events->invoke("MANIPULATOR_SCALE");

    if (event->is_action_pressed("avi_camera_technical"))
        events->invoke("CAMERA_TECHNICAL");
    if (event->is_action_pressed("avi_camera_playful"))
        events->invoke("CAMERA_PLAYFUL");
}
