#include "Clock.h"

avi::connection::Clock::Clock() = default;

void
avi::connection::Clock::setTimeFrame(avi::connection::TimeFrame frame)
{
    fullFrame = frame;
    setAvailableTimeFrame(TimeFrame(0, 0));
    setTargetTime(0);
}

avi::connection::TimeFrame
avi::connection::Clock::getTimeFrame()
{
    return fullFrame;
}

void
avi::connection::Clock::setAvailableTimeFrame(avi::connection::TimeFrame frame)
{
    availableFrame = frame;
}

avi::connection::TimeFrame
avi::connection::Clock::getAvailableTimeFrame()
{
    return availableFrame;
}

void
avi::connection::Clock::advance(long time)
{
    if ((fullFrame.begin + targetTime + (long)((long double)speed * time) <= fullFrame.end) &&
        (fullFrame.begin + targetTime + (long)((long double)speed * time) >= fullFrame.begin))
    {
        targetTime += (long)((long double)speed * time);
    }
}

void
avi::connection::Clock::setTargetTime(long time)
{
    if (time <= fullFrame.end)
    {
        targetTime = time;
    }
    else
    {
        if (targetTime + 1 <= fullFrame.end)
        {
            targetTime++;
        }
    }
}

long
avi::connection::Clock::getTargetTime() const
{
    return targetTime;
}

void
avi::connection::Clock::setSpeed(float add)
{
    speed = add;
}

float
avi::connection::Clock::getSpeed() const
{
    return speed;
}
