#pragma once

#include "TimeFrame.h"

namespace avi::connection
{
    class Clock
    {
    public:
        Clock();

        void setTimeFrame(avi::connection::TimeFrame frame);

        avi::connection::TimeFrame getTimeFrame();

        void setAvailableTimeFrame(avi::connection::TimeFrame frame);

        avi::connection::TimeFrame getAvailableTimeFrame();

        [[nodiscard]] float getSpeed() const;

        void advance(long time);

        void setTargetTime(long time);

        [[nodiscard]] long getTargetTime() const;

        void setSpeed(float add);

    private:
        avi::connection::TimeFrame fullFrame = avi::connection::TimeFrame(0, 0);
        avi::connection::TimeFrame availableFrame = avi::connection::TimeFrame(0, 0);

        long targetTime = 0;
        float speed = 0.0;
    };
} // namespace avi::connection
