#include "Interaction.h"

avi::connection::Interaction
avi::connection::Interaction::createSelection(avi::core::Element* element)
{
    avi::connection::Interaction interaction;
    interaction.interactionType = InteractionType::SELECTION;
    interaction.element = element;

    return interaction;
}

avi::connection::Interaction
avi::connection::Interaction::createDeselection(avi::core::Element* element)
{
    avi::connection::Interaction interaction;
    interaction.interactionType = InteractionType::DESELECTION;
    interaction.element = element;

    return interaction;
}

avi::connection::Interaction
avi::connection::Interaction::createManipulation(avi::core::Element* element,
                                                 godot::Vector3 translation,
                                                 godot::Quat rotation,
                                                 godot::Vector3 scale,
                                                 Transformation transformation)
{
    avi::connection::Interaction interaction;
    interaction.interactionType = InteractionType::MANIPULATION;
    interaction.transformation = transformation;

    interaction.element = element;
    interaction.translation = translation;
    interaction.rotation = rotation;
    interaction.scale = scale;

    return interaction;
}

avi::connection::Interaction
avi::connection::Interaction::createOption(avi::core::Element* element, int64_t option)
{
    avi::connection::Interaction interaction;
    interaction.interactionType = InteractionType::OPTION;

    interaction.element = element;
    interaction.option = option;

    return interaction;
}

InteractionType
avi::connection::Interaction::getType()
{
    return this->interactionType;
}

std::optional<int64_t>
avi::connection::Interaction::getOption()
{
    return this->option;
}

godot::Vector3
avi::connection::Interaction::getTranslation()
{
    return this->translation;
}

godot::Quat
avi::connection::Interaction::getRotation()
{
    return this->rotation;
}

godot::Vector3
avi::connection::Interaction::getScale()
{
    return this->scale;
}

avi::core::Element*
avi::connection::Interaction::getElement()
{
    return element;
}

avi::connection::Interaction::Transformation
avi::connection::Interaction::getTransformation()
{
    return this->transformation;
}
