#pragma once

#include <arviz_godot/lib/avi/connection/Component.h>
#include <arviz_godot/lib/avi/connection/StorageAdapter.h>

namespace avi::connection
{
    class LiveStorageAdapter : public avi::connection::StorageAdapter
    {
    public:
        explicit LiveStorageAdapter(avi::connection::Component& component);

        ~LiveStorageAdapter() override = default;

        armarx::viz::data::LayerUpdates getLayerUpdates() override;

        std::vector<std::string> getAllReplays() override;

        void setup() override;

        void setInteraction(std::vector<avi::connection::Interaction> newInteractions) override;

    private:
        avi::connection::Component& component;

        int64_t lastRevision{0};

        std::vector<armarx::viz::data::InteractionFeedback> interactions;

        static armarx::Vector3f convertVector(godot::Vector3 vec);
    };
} // namespace avi::connection
