#pragma once

#include <map>
#include <mutex>
#include <optional>
#include <set>

#include <RobotAPI/components/ArViz/ArVizStorage.h>

namespace avi::connection
{
    using LayerRevision = std::pair<std::string, std::string>;

    class RevisionBuffer
    {
    public:
        void addUpdates(armarx::viz::data::LayerUpdates&& revision);

        std::set<LayerRevision> getChangedLayers();

        std::optional<armarx::viz::data::LayerUpdate> getUpdate(const LayerRevision& layer);

        void clearBuffer();

    private:
        std::map<LayerRevision, armarx::viz::data::LayerUpdate> updates;

        std::set<LayerRevision> changed;

        std::mutex bufferLock;
    };
} // namespace avi::connection
