#pragma once

#include <memory>
#include <vector>

#include <arviz_godot/lib/avi/connection/Clock.h>

namespace avi::connection
{
    class StorageModeSwitch
    {
    public:
        virtual bool isLive() const = 0;

        virtual bool isRecording() const = 0;

        virtual void recordReplay(const std::string& name) = 0;

        virtual void endRecording() = 0;

        virtual std::vector<std::string> getAllReplays() = 0;

        virtual void useLiveTiming() = 0;

        virtual void useReplayTiming(const std::string& replay,
                                     std::shared_ptr<avi::connection::Clock> clock) = 0;

        virtual ~StorageModeSwitch() = default;
    };
} // namespace avi::connection
