#pragma once

#include <optional>

#include <Godot.hpp>
#include <Node.hpp>
#include <arviz_godot/lib/avi/core/Element.h>
#include <arviz_godot/lib/avi/core/ScreenContent.h>

namespace avi::core
{
    class Camera
    {
    public:
        virtual void activate() = 0;

        virtual avi::core::ScreenContent getCurrentScreenContent() = 0;

        virtual godot::Vector2 getScreenSize() = 0;

        virtual std::optional<std::pair<avi::core::Element*, godot::Node*>>
        getSelectedElement(godot::Vector2 point) = 0;

        virtual std::optional<std::pair<avi::core::Element*, godot::Node*>>
        getSelectedElement(godot::Vector2 point, bool& anyHit) = 0;

        virtual ~Camera() = default;
    };
} // namespace avi::core
