#pragma once

#include <utility>

/**
 * Prevents destructor call of a value.
 * Adapted from: http://wg21.link/p1247r0
 */
template <class T>
class no_destroy
{
    alignas(T) std::array<std::byte, sizeof(T)> data;

public:
    template <class... Ts>
    no_destroy(Ts&&... ts)
    {
        new (data.data()) T(std::forward<Ts>(ts)...);
    }

    T&
    get()
    {
        return *reinterpret_cast<T*>(data.data());
    }
};
