#pragma once

#include <VirtualRobot/Import/MeshImport/AssimpReader.h>

#include <Mesh.hpp>
#include <SpatialMaterial.hpp>
#include <arviz_godot/lib/avi/core/Cache.h>
#include <arviz_godot/lib/avi/core/Object.h>

namespace avi::core
{
    class ModelLoader
    {
    public:
        VirtualRobot::ManipulationObjectPtr getObject(const std::string& name);

        avi::core::Object loadModel(const std::string& name, std::string& fullName);
        avi::core::Object loadModelFromFile(const std::string& name);

        avi::core::Cache<godot::Mesh*, avi::core::Shape>& getShapeCache();

        ModelLoader();

        static avi::core::Object
        createObjectFromTriMesh(std::shared_ptr<VirtualRobot::TriMeshModel> model);

        void clearCaches();

    private:
        avi::core::Object loadModelFromNonObjFile(const std::string& name);

        avi::core::Object error();

        avi::core::Cache<std::string, avi::core::Object> modelCache;
        avi::core::Cache<godot::Mesh*, avi::core::Shape> shapeCache;

        godot::Mesh* errorMesh;
        godot::SpatialMaterial* errorMaterial;
    };
} // namespace avi::core
