#include "ValueOption.h"

template<typename V, typename T>
avi::core::ValueOption<V, T>::ValueOption(std::string key, std::string label, V& value) :
    Option<T>(std::move(key), std::move(label)), value(value)
{}

template<typename V, typename T>
void avi::core::ValueOption<V, T>::accept(T& transformer)
{
    transformer.template transform<V>(*this);
}

template<typename V, typename T>
void avi::core::ValueOption<V, T>::setValue(V value)
{
    this->value = value;
}

template<typename V, typename T>
const V& avi::core::ValueOption<V, T>::getValue()
{
    return value;
}
