#include "CameraModeMenu.h"

void
avi::gui::CameraModeMenu::_register_methods()
{
    godot::register_method("_ready", &avi::gui::CameraModeMenu::_ready);
    godot::register_method("_process", &avi::gui::CameraModeMenu::_process);
}

void
avi::gui::CameraModeMenu::_init()
{
}

void
avi::gui::CameraModeMenu::_process()
{
    setActiveManipulator();
}

void
avi::gui::CameraModeMenu::_ready()
{
    this->modeCount = this->get_item_count();
}

void
avi::gui::CameraModeMenu::setup(avi::core::EventInvokingSystem& invokingSystem,
                                avi::core::EventSubscriptionSystem& eventSubscriptionSystem)
{
    this->events = &invokingSystem;

    eventSubscriptionSystem.subscribe("CAMERA_TECHNICAL",
                                      [this]() -> void { this->select(CAMERA_TECHNICAL); });
    eventSubscriptionSystem.subscribe("CAMERA_PLAYFUL",
                                      [this]() -> void { this->select(CAMERA_PLAYFUL); });

    this->set_item_text(CAMERA_TECHNICAL, "Technical [1]");
    this->set_item_text(CAMERA_PLAYFUL, "Playful [2]");
}

int
avi::gui::CameraModeMenu::getSelectedItemID()
{
    for (int i = 0; i < modeCount; i++)
    {
        if (this->is_selected(i))
        {
            return i;
        }
    }

    return -1;
}

void
avi::gui::CameraModeMenu::setActiveManipulator()
{
    int activeManipulatorID = getSelectedItemID();

    switch (activeManipulatorID)
    {
        case CAMERA_TECHNICAL:
            avi::gui::CameraModeMenu::disableActiveItemText();

            if (current != CAMERA_TECHNICAL)
                events->invoke("VIEW_SCHEME_SWITCH");
            current = CAMERA_TECHNICAL;

            break;

        case CAMERA_PLAYFUL:
            avi::gui::CameraModeMenu::disableActiveItemText();

            if (current != CAMERA_PLAYFUL)
                events->invoke("VIEW_SCHEME_SWITCH");
            current = CAMERA_PLAYFUL;

            break;

        default:
            break;
    }
}

void
avi::gui::CameraModeMenu::disableActiveItemText()
{
}
