#pragma once

#include <Control.hpp>
#include <Godot.hpp>
#include <ItemList.hpp>
#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>

namespace avi::gui
{
    class CameraModeMenu : public godot::ItemList
    {
        GODOT_CLASS(CameraModeMenu, Control)

    public:
        virtual ~CameraModeMenu() = default;

        static void _register_methods();

        void _init();

        void _process();

        void _ready();

        void setup(avi::core::EventInvokingSystem& invokingSystem,
                   avi::core::EventSubscriptionSystem& eventSubscriptionSystem);

    private:
        avi::core::EventInvokingSystem* events;

        int modeCount;

        enum Selection
        {
            CAMERA_TECHNICAL = 0,
            CAMERA_PLAYFUL = 1,
        };

        Selection current{CAMERA_TECHNICAL};

        int getSelectedItemID();

        void setActiveManipulator();

        void disableActiveItemText();
    };
} // namespace avi::gui
