#pragma once

#include <CheckBox.hpp>
#include <Control.hpp>
#include <Godot.hpp>
#include <ItemList.hpp>
#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>
#include <arviz_godot/lib/avi/interaction/ManipulationMode.h>
#include <arviz_godot/lib/avi/interaction/Manipulator.h>

namespace avi::gui
{
    class ManipulationMenu : public godot::ItemList
    {
        GODOT_CLASS(ManipulationMenu, Control)

    public:
        virtual ~ManipulationMenu() = default;

        static void _register_methods();

        void _init();

        void _process();

        void _ready();

        void setup(avi::interaction::Manipulator& manipulator,
                   avi::core::EventSubscriptionSystem& eventSubscriptionSystem);

    private:
        avi::interaction::Manipulator* manipulator{};

        int manipulatorCount;

        enum Selection
        {
            MANIPULATOR_NONE = 0,
            MANIPULATOR_MOVE = 1,
            MANIPULATOR_ROTATE = 2,
            MANIPULATOR_SCALE = 3,
        };

        ManipulationMode selectionMode;

        int getSelectedItemID();
        void setActiveManipulator();
        void disableActiveItemText();
    };
} // namespace avi::gui
