#pragma once

#include <functional>
#include <vector>

#include <Godot.hpp>
#include <PopupMenu.hpp>

namespace avi::gui
{
    class SelectionMenu : public godot::PopupMenu
    {
        GODOT_CLASS(SelectionMenu, godot::PopupMenu)

    public:
        virtual ~SelectionMenu() = default;

        static void _register_methods();

        void _init();

        void _ready();

        void open(godot::Vector2 mousePosition,
                  std::vector<std::string>& options,
                  std::function<void(int64_t)> callback);

    private:
        std::vector<std::string> options;
        std::function<void(int64_t)> callback;

        void sendInteraction();
    };
} // namespace avi::gui
