#include "Move.h"

#include <arviz_godot/lib/avi/interaction/Manipulator.h>

void
avi::interaction::Move::_register_methods()
{
    register_method("_process", &Move::_process);
}

void
avi::interaction::Move::_init()
{
}

void
avi::interaction::Move::_process(float delta)
{
}

void
avi::interaction::Move::setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy)
{
    this->manipulator = &manipulator;
    this->proxy = proxy;

    this->XAxisGizmo = get_node<avi::interaction::MoveAxisGizmo>("Scaler/X Axis");
    this->YAxisGizmo = get_node<avi::interaction::MoveAxisGizmo>("Scaler/Y Axis");
    this->ZAxisGizmo = get_node<avi::interaction::MoveAxisGizmo>("Scaler/Z Axis");

    XAxisGizmo->setup(*this, xAxis);
    YAxisGizmo->setup(*this, yAxis);
    ZAxisGizmo->setup(*this, zAxis);

    this->hide();
}

void
avi::interaction::Move::targetElement(avi::scene::ElementNode& elementNode)
{
    XAxisGizmo->setActive(false);
    YAxisGizmo->setActive(false);
    ZAxisGizmo->setActive(false);

    if (elementNode.translationX())
    {
        XAxisGizmo->setActive(true);
    }
    if (elementNode.translationY())
    {
        YAxisGizmo->setActive(true);
    }
    if (elementNode.translationZ())
    {
        ZAxisGizmo->setActive(true);
    }

    this->elementNode = &elementNode;
    manipulator->setGizmoTransform(
        this, this->elementNode->getTransform(), this->elementNode->translationLocal());
}

void
avi::interaction::Move::deactivate()
{
    this->hide();
}

void
avi::interaction::Move::activate()
{
    this->show();
}

void
avi::interaction::Move::updateTransform(const godot::Transform& global)
{
    proxy->set_global_transform(global);

    manipulator->setGizmoTransform(
        this, this->get_transform(), this->elementNode->translationLocal());
    manipulator->sendManipulation();
}

void
avi::interaction::Move::updateRelease()
{
    manipulator->endManipulation();
}

godot::Spatial*
avi::interaction::Move::get_proxy()
{
    return proxy;
}
