#pragma once

#include <Godot.hpp>
#include <Spatial.hpp>
#include <arviz_godot/lib/avi/interaction/RotateAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class None : public godot::Spatial
    {
        GODOT_CLASS(None, Spatial)

    public:
        virtual ~None() = default;

        static void _register_methods();

        void _init();

        void setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Spatial* proxy;

        avi::scene::ElementNode* elementNode{};
    };
} // namespace avi::interaction
