#include "Rotate.h"

#include <arviz_godot/lib/avi/interaction/Manipulator.h>

void
avi::interaction::Rotate::_register_methods()
{
}

void
avi::interaction::Rotate::_init()
{
}

void
avi::interaction::Rotate::setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy)
{
    this->manipulator = &manipulator;
    this->proxy = proxy;

    this->XAxisGizmo = get_node<avi::interaction::RotateAxisGizmo>("Scaler/X Axis");
    this->YAxisGizmo = get_node<avi::interaction::RotateAxisGizmo>("Scaler/Y Axis");
    this->ZAxisGizmo = get_node<avi::interaction::RotateAxisGizmo>("Scaler/Z Axis");

    XAxisGizmo->setup(*this, 0);
    YAxisGizmo->setup(*this, 1);
    ZAxisGizmo->setup(*this, 2);
    this->hide();
}

void
avi::interaction::Rotate::targetElement(avi::scene::ElementNode& elementNode)
{
    XAxisGizmo->setActive(false);
    YAxisGizmo->setActive(false);
    ZAxisGizmo->setActive(false);

    if (elementNode.rotationX())
    {
        XAxisGizmo->setActive(true);
    }
    if (elementNode.rotationY())
    {
        YAxisGizmo->setActive(true);
    }
    if (elementNode.rotationZ())
    {
        ZAxisGizmo->setActive(true);
    }

    this->elementNode = &elementNode;
    manipulator->setGizmoTransform(
        this, this->elementNode->getTransform(), this->elementNode->rotationLocal());
}

void
avi::interaction::Rotate::deactivate()
{
    this->hide();
}

void
avi::interaction::Rotate::activate()
{
    this->show();
}

void
avi::interaction::Rotate::updateTransform(const godot::Transform& local)
{
    if (elementNode->rotationLocal())
    {
        this->set_transform(local.orthonormalized());
    }

    proxy->set_transform(local);
    manipulator->sendManipulation();
}

void
avi::interaction::Rotate::updateRelease()
{
    manipulator->endManipulation();
}

godot::Spatial*
avi::interaction::Rotate::get_proxy()
{
    return proxy;
}
