#pragma once

#include <memory>
#include <optional>

#include <Camera.hpp>
#include <Godot.hpp>
#include <StaticBody.hpp>
#include <arviz_godot/lib/avi/interaction/godot/Interaction.h>

namespace godot
{
    class Manipulator;
}

namespace avi::interaction
{
    class Rotate;

    class RotateAxisGizmo : public godot::StaticBody
    {
        GODOT_CLASS(RotateAxisGizmo, StaticBody)

    public:
        static void _register_methods();

        RotateAxisGizmo();
        virtual ~RotateAxisGizmo();

        void _init();

        void _input(godot::InputEvent* event);

        void on_input_event(godot::Object* camera,
                            godot::InputEvent* event,
                            godot::Vector3 position,
                            godot::Vector3 normal,
                            int64_t shape_idx);

        void setup(avi::interaction::Rotate& rotate, int axis);

        void setActive(bool activeStatus);

        void _process(float delta);

    private:
        bool moved = false;
        godot::Camera* camera;

        std::optional<godot::Interaction> data;

        avi::interaction::Rotate* rotate{};
        int axis = 0;

        std::unique_ptr<godot::Manipulator> manipulator;
    };

} // namespace avi::interaction
