#pragma once

#include <arviz_godot/lib/avi/scene/ViewCamera.h>

namespace avi::scene
{
    class ViewCamera;

    class CameraControlScheme
    {
    public:
        virtual void takeOver(avi::scene::ViewCamera* viewCamera) = 0;

        virtual void release() = 0;

        virtual void reset() = 0;

        virtual void focus(godot::AABB box) = 0;

        virtual void focus(godot::Vector3 point, avi::core::Element*) = 0;

        virtual godot::Basis getRotationBasis() = 0;

        virtual ~CameraControlScheme() = default;
    };
} // namespace avi::scene
