#pragma once

#include "MeshElementNode.h"
#include <CylinderMesh.hpp>

namespace avi::scene
{
    class CylinderElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(CylinderElementNode, ElementNode)

    public:
        ~CylinderElementNode() override = default;

        static void _register_methods();

        void _ready();

        void _init();

        static CylinderElementNode* newCylinderElementNode(std::string name,
                                                           avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        float height = 0.0f;
        float radius = 0.0f;
    };
} // namespace avi::scene
