#pragma once

#include "MeshElementNode.h"
#include <CylinderMesh.hpp>

namespace avi::scene
{
    class CylindroidElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(CylindroidElementNode, ElementNode)

    public:
        ~CylindroidElementNode() override = default;

        static void _register_methods();

        void _ready();

        void _init();

        static CylindroidElementNode* newCylindroidElementNode(std::string name,
                                                               avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        float height = 0.0f;
    };
} // namespace avi::scene
