#pragma once

#include "MeshElementNode.h"
#include <SphereMesh.hpp>

namespace avi::scene
{
    class EllipsoidElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(EllipsoidElementNode, ElementNode)

    public:
        ~EllipsoidElementNode() override = default;

        static void _register_methods();

        void _ready();

        void _init();

        static EllipsoidElementNode* newEllipsoidElementNode(std::string name,
                                                             avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        godot::Vector3 scale;
    };
} // namespace avi::scene
