#include "OrientationIndicator.h"

#include <arviz_godot/lib/avi/scene/CameraControlScheme.h>
#include <arviz_godot/lib/avi/scene/PlayfulControlScheme.h>
#include <arviz_godot/lib/avi/scene/TechnicalControlScheme.h>

avi::scene::OrientationIndicator::OrientationIndicator()
{
}

void
avi::scene::OrientationIndicator::_init()
{
}

void
avi::scene::OrientationIndicator::_register_methods()
{
    register_method("_ready", &OrientationIndicator::_ready);
    register_method("_process", &OrientationIndicator::_process);
}

void
avi::scene::OrientationIndicator::_ready()
{
    pose = get_node<godot::MeshInstance>("Pose");
    godot::Vector2 viewportSize = godot::Vector2(1000, 1000);
    this->set_size(viewportSize);
}

void
avi::scene::OrientationIndicator::_process()
{
    CameraControlScheme* scheme = viewCamera->getCurrentScheme();

    pose->set_rotation_degrees(scene->getOrientation());
    if (dynamic_cast<TechnicalControlScheme*>(scheme))
    {
        pose->set_rotation(
            (scheme->getRotationBasis() * pose->get_transform().basis.orthonormalized())
                .get_euler());
    }
    else
    {
        pose->set_rotation(
            ((scheme->getRotationBasis().inverse()) * pose->get_transform().basis.orthonormalized())
                .orthonormalized()
                .get_euler());
    }
}

void
avi::scene::OrientationIndicator::setup(avi::scene::VisualizedScene* scene,
                                        avi::scene::ViewCamera* viewCamera)
{
    this->viewCamera = viewCamera;
    this->scene = scene;
}
