#pragma once

#include "ElementNode.h"
#include <Godot.hpp>
#include <arviz_godot/lib/avi/scene/PoseElementNode.h>
#include <arviz_godot/lib/avi/scene/VisualizedScene.h>

namespace avi::scene
{
    class OrientationIndicator : public godot::Viewport
    {
        GODOT_CLASS(OrientationIndicator, godot::Viewport)

    public:
        OrientationIndicator();
        ~OrientationIndicator() = default;

        void _init();

        static void _register_methods();

        void _process();

        void _ready();

        void setup(avi::scene::VisualizedScene* scene, avi::scene::ViewCamera* viewCamera);

    private:
        avi::scene::VisualizedScene* scene;
        avi::scene::ViewCamera* viewCamera;
        godot::MeshInstance* pose;
    };
} // namespace avi::scene
