#pragma once

#include "MeshElementNode.h"
#include <CubeMesh.hpp>

namespace avi::scene
{
    class SphereElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(SphereElementNode, ElementNode)

    public:
        ~SphereElementNode() override = default;
        static void _register_methods();

        void _ready();

        void _init();

        static SphereElementNode* newSphereElementNode(std::string name, avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        float radius = 0.0f;
    };
} // namespace avi::scene
