#include <functional>

#include <arviz_godot/lib/avi/app/EventList.h>
#include <catch2/catch_test_macros.hpp>

TEST_CASE("test event system with one function", "[EventList]")
{
    avi::app::EventList eventList;
    bool bool1 = false;
    std::function<void()> function1 = [&bool1]() { bool1 = true; };
    eventList.subscribe("event1", function1);
    eventList.invoke("event1");
}

TEST_CASE("test event system with multiple functions", "[EventList]")
{
    avi::app::EventList eventList;
    bool bool1 = false;
    bool bool2 = false;
    std::function<void()> function1 = [&bool1]() { bool1 = true; };
    std::function<void()> function2 = [&bool2]() { bool2 = true; };
    eventList.subscribe("event1", function1);
    eventList.subscribe("event1", function2);
    REQUIRE_FALSE(bool1);
    REQUIRE_FALSE(bool2);
    eventList.invoke("event1");

    REQUIRE(bool1);
    REQUIRE(bool2);
}
