#include <Vector3.hpp>
#include <arviz_godot/lib/avi/core/Utilities.h>
#include <catch2/catch_test_macros.hpp>

TEST_CASE("get closest point on rays", "[Utilities]")
{
    godot::Vector3 ro1 = {0, 0, 0};
    godot::Vector3 rd1 = {1, 0, 0};
    godot::Vector3 ro2 = {0, 1, 0};
    godot::Vector3 rd2 = {0, 0, 1};

    std::pair<godot::Vector3, godot::Vector3> result =
        avi::core::utilities::getClosestPointsOnRays(ro1, rd1, ro2, rd2);
    REQUIRE(result.first == godot::Vector3{0, 0, 0});
    REQUIRE(result.second == godot::Vector3{0, 1, 0});
}
